<template>
  <div style="padding-left: 120px">
    <p style="font-size: 36px" class=" mb-4 opacity-60 pl-4">Ряд №</p>
    <div style="height: 2px;width: 131px;background-color: #673AB7"></div>
  </div>
  <div class="h-16 w-full border-t-2 border-b-2 mb-6 num-wrap flex text-center relative" style="padding-left: 90px">
    <div class="absolute left-8 opacity-60" style="font-size: 34px; width: 51px">0</div>
    <div class="absolute right-8 opacity-60" style="font-size: 34px; width: 51px">0</div>
    <div v-for="index in getReversedIndexes" v-show="index !== 74" style="font-size: 34px; width: 51px" class="opacity-60">{{ index }}</div>
  </div>
  <div class="relative mt-12 box-container">
    <div class="flex box-wrap">
      <div v-for="(n, index) in database" v-show="n.street !== 0" class="flex elem-wrap relative" style="margin-right: 1px">
        <div class="flex relative">
          <div
            :class="{
              'red': n.perc_fill_mezo_volume > 65,
              'yellow': n.perc_fill_mezo_volume < 65 && n.perc_fill_mezo_volume > 40,
              'green': n.perc_fill_mezo_volume < 40,
            }"
            class="line"></div>
          <div
            :class="{
              'opacity-0': n.street===1,
              'red': n.perc_fill_mezo_volume > 65,
              'yellow': n.perc_fill_mezo_volume < 65 && n.perc_fill_mezo_volume > 40,
              'green': n.perc_fill_mezo_volume < 40,
            }"
            class="line-1"></div>
        </div>

        <div v-if="index === 2 || index === 21 || index === 39 || index === 57 || index === 71" class="ladder"
             :style="{
              zIndex: 2,
              top: '570px',
              left: '-11px'
           }"
        ></div>
        <div v-if="index === 21 || index === 65" class="ladder"
             :style="{
              zIndex: 2,
              top: '0',
              left: '-11px'
           }"
        ></div>
      </div>

      <div
        :class="{
              'red':database[72].perc_fill_mezo_volume > 65,
              'yellow':database[72].perc_fill_mezo_volume < 65 &&database[72].perc_fill_mezo_volume > 40,
              'green':database[72].perc_fill_mezo_volume < 40,
            }"
        class="horizontal-line"
        style="top: -30px"
      ></div>
    </div>
    <div class="flex box-wrap">
      <div v-for="(n, index) in database" v-show="n.street !== 0" class="flex elem-wrap relative" style="margin-right: 1px">
        <div class="flex relative">
          <div
            :class="{
              'opacity-0': n.street===53 || n.street===35 || n.street===17,
              'red': n.perc_fill_mezo_volume > 65,
              'yellow': n.perc_fill_mezo_volume < 65 && n.perc_fill_mezo_volume > 40,
              'green': n.perc_fill_mezo_volume < 40,
              'pink': ((n.street <= 73 && n.street > 54) || (n.street <= 52 && n.street > 36)) && isSafe
            }"
            class="line"></div>
          <div
            :class="{
              'opacity-0': n.street===1 || n.street===54 || n.street===36 || n.street===18,
              'red': n.perc_fill_mezo_volume > 65,
              'yellow': n.perc_fill_mezo_volume < 65 && n.perc_fill_mezo_volume > 40,
              'green': n.perc_fill_mezo_volume < 40,
              'pink': (n.street <= 71 && n.street > 54 || (n.street <= 52 && n.street > 36)) && isSafe
            }"
            class="line-1"></div>
        </div>
        <div v-if="index === 2 || index === 21 || index === 39 || index === 57 || index === 71" class="ladder"
             :style="{
              zIndex: 2,
              top: '535px',
              left: '-11px'
           }"
        ></div>
        <div v-if="n.street === 53 || n.street === 35 || n.street === 17" class="down-block w-8 h-12 absolute right-9 bottom-0"></div>
      </div>
    </div>
    <div
      :class="{
              'red': database[1].perc_fill_mezo_volume > 65,
              'yellow':database[1].perc_fill_mezo_volume < 65 &&database[1].perc_fill_mezo_volume > 40,
              'green':database[1].perc_fill_mezo_volume < 40,
            }"
      class="vertical-line top-0 left-22"
    ><span class="mt-2 flex"></span></div>
    <div
      :class="{
              'red':database[71].perc_fill_mezo_volume > 65,
              'yellow':database[71].perc_fill_mezo_volume < 65 &&database[71].perc_fill_mezo_volume > 40,
              'green':database[71].perc_fill_mezo_volume < 40,
            }"
      class="vertical-line top-0 right-0 123"
    ></div>
  </div>
  <div style="padding-left: 90px" class="flex">
    <div class="flex items-center mr-16"><span class="w-20 h-20 mr-4 green inline-flex rounded"></span><span class="text-5xl opacity-70">Мест много</span></div>
    <div class="flex items-center mr-16"><span class="w-20 h-20 mr-4 yellow inline-flex rounded"></span><span class="text-5xl opacity-70">Мест ограничено</span></div>
    <div class="flex items-center mr-16"><span class="w-20 h-20 mr-4 red inline-flex rounded"></span><span class="text-5xl opacity-70">Раскладка запрещена</span></div>
    <div class="flex items-center mr-16"><span class="w-20 h-20 mr-4 gray inline-flex rounded"></span><span class="text-5xl opacity-70">Лестница</span></div>
    <div class="flex items-center mr-16"><span class="w-20 h-20 mr-4 down-block inline-flex rounded"></span><span class="text-5xl opacity-70">Спуск</span></div>
  </div>
</template>

<script>
import {computed, ref} from "vue";
import db from "../../data.json";

export default {
  name: "Store1",
  props: {
    isSafe: {type: Boolean, default: false},
    store: {type: String, default: false},
    stage: {type: String, default: false},
  },
  setup(props) {
    let database
    console.log(db.kazan2[props.stage])
    if (props.store === '1') {
      if (props.stage === '1') database = db.kazan1['1'][0].filter(el => el.street !== 73 )
      else  database = db.kazan1[props.stage][0]
    }
    if (props.store === '2') database = db.kazan2[props.stage][0]
    const getReversedIndexes = computed(() => {
      const length = database.length - 1;
      return Array.from({ length }, (_, i) => length - i);
    })
    database = database.sort((a, b) => b.street - a.street)
    return {
      database,
      getReversedIndexes
    }
  },
}
</script>

<style lang="scss" scoped>
.green {background-color: #219653}
.yellow {background-color: #F2C94C}
.pink {background-color: #FCDDEC!important;}
.red {background-color: #EB5757}
.gray {background-color: #333333}

.down-block {
  background: linear-gradient(to bottom right, #FF7800 50%, #333333 50%);
}

.ladder {
  position: absolute;
  display: flex;
  align-items: center;
  justify-content: center;
  width: 21px;
  height: 30px;
  background-color: #333333;
  outline: 2px solid white;
  &::before {
    content: '';
    width: 2px;
    height: 100%;
    background-color: white;
  }
}

.box-container{
  margin-left: 90px;
  margin-right: 75px;
}
.box-wrap {
  height: 600px;
  margin-bottom: 60px;

  .elem-wrap {
    height: 100%;
    .line, .line-1 {
      width: 10px;
      border-radius: 5px;
    }
    .line {
      margin-right: 29px;
    }
    .line-1 {
      margin-right: 1px;
    }
  }
}
.horizontal-line {
  position: absolute;
  height: 10px;
  width: 100%;
  border-radius: 4px;
}
.vertical-line {
  position: absolute;
  width: 10px;
  height: 100%;
  border-radius: 4px;
}
.solo-line-top, .solo-line-bot {
  height: calc(100% + 40px);
  //transform: translate(0, -40px);
}
.solo-line-bot {
  transform: translate(0, -40px);
}
</style>
